<?xml version="1.0"?>

<st-source>
<time-stamp>From VisualWorks®, 7.3.1 of April 20, 2005 on November 13, 2008 at 12:31:25 pm</time-stamp>
<!-- Package Changes for PV-SNMP Collector(Green.20,srobin)*
	Environment: PROVISO -->


<methods>
<class-id>PROVISO.ProbeDatabaseInterface</class-id> <category>accessing</category>

<body package="PV-SNMP Collector" selector="routerProbePropertiesForCollector:do:">routerProbePropertiesForCollector: collectorId do: aBlock

	| sql propMap propertyList propIdString bindVars |
	propertyList := #('probeRebootCheckInterval' 'probeResyncInterval').
	propMap := Dictionary new.
	propertyList do: [ :propName | propMap at: (self propertyIdFor: propName) put: propName].
	
	sql := 
		'Select /*+ USE_NL(r p) NO_MERGE(r) */ r.Idx_Ind, p.Idx_Metric, p.Str_Value
  			From Prop_Desc p,
       			( Select e.Idx_Ind
           				From ELMT_DESC e
          				Where e.Int_Collector = :1
          			Union All
         			Select /*+ USE_NL(e s) */ s.Idx_Ind
           				From SE_DESC s, ELMT_DESC e
					Where 
						e.Idx_Ind = s.Idx_Host And 
						e.Int_Collector = :1 ) r
			Where 
				p.Idx_Resource = r.Idx_Ind And 
				p.Idx_Metric In ( &lt;1s&gt; )'.

	propIdString := String streamContents: [ :s | (2 to: (propMap size + 1)) do: [ :i | s nextPutAll: ':'; print: i] separatedBy: [s nextPutAll: ', ']].
	bindVars := (Array with: collectorId), propMap keys asArray.
	self dbSession 
		readRowsWith: (sql expandMacrosWith: propIdString)
		bindVars: bindVars
		into: [ :row | aBlock value: row first value: (propMap at: row second) value: row third ].</body>
</methods>


</st-source>
